<template>
  <div>

    <div class="jumbotron">
      <h3>Aktualne dane: </h3>
      <div>Nazwa Pasieki: {{ actualBeegarden.beegardenName }}</div>
      <div>Typ Pasieki: {{ actualBeegarden.type }}</div>
      <div>Lokalizacja Pasieki: {{ actualBeegarden.location }}</div>
    </div>

    <h2> Edytuj pasiekę: </h2>
    <form
        v-on:submit.prevent="submitForm"
    >

      <div class="form-group">
        <label for="beegardenName">Nowa nazwa:</label>
        <input type="text"
               class="form-control"
               id="beegardenName"
               placeholder="Nowa nazwa pasieki"
               @input="e => this.form.beegardenName = e.target.value"
               required
        />
      </div>

      <div class="form-group">
        <label>Nowy rodzaj pasieki: </label>

        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_stacjonarna"
                 value="Stacjonarna"
                 @input="e => form.type = e.target.value"
                 :checked="actualBeegarden.type ==='Stacjonarna'"
          >
          <label class="form-check-label" for="type_stacjonarna">Stacjonarna</label>
        </div>

        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_wedrowna"
                 value="Wędrowna"
                 @input="e => form.type = e.target.value"
                 :checked="actualBeegarden.type ==='Wędrowna'"
          >
          <label class="form-check-label" for="type_wedrowna">Wędrowna</label>
        </div>

        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_amatorska"
                 value="Amatorska"
                 @input="e => form.type = e.target.value"
                 :checked="actualBeegarden.type === 'Amatorska'"
          >
          <label class="form-check-label" for="type_amatorska">Amatorska</label>
        </div>

        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_towarowa"
                 value="Towarowa"
                 @input="e => form.type = e.target.value"
                 :checked="actualBeegarden.type === 'Towarowa'"
          >
          <label class="form-check-label" for="type_towarowa">Towarowa</label>
        </div>

        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_przydomowa"
                 value="Przydomowa"
                 @input="e => form.type = e.target.value"
                 :checked="actualBeegarden.type === 'Przydomowa'"
          >
          <label class="form-check-label" for="type_przydomowa">Przydomowa</label>
        </div>

        <div class="form-check form-check-inline">
          <input class="form-check-input"
                 type="radio"
                 name="type"
                 id="type_specjalistyczna"
                 value="Specjalistyczna"
                 @input="e => form.type = e.target.value"
                 :checked="actualBeegarden.type === 'Specjalistyczna'"
          >
          <label class="form-check-label" for="type_specjalistyczna">Specjalistyczna</label>
        </div>
      </div>

      <div class="form-group">
        <label for="beegardenLocation">Nowa lokalizacja: </label>
        <input type="text"
               id="beegardenLocation"
               class="form-control"
               placeholder="Nowa lokalizacja pasieki"
               @input="e => this.form.location = e.target.value"
               required
        />
      </div>

      <div class="form-group">
        <button class="btn btn-primary">Edytuj</button>
      </div>
      <div>
        <button class="btn btn-dark" v-on:click="getBackToBoardBeegarden()">Anuluj</button>
      </div>
    </form>
  </div>
</template>

<script>
import BeegardenService from '../../services/beegarden.service';
import beegardenobject from '../../models/beegardenobject.js'

export default {
  name: 'EditBeegarden',
  data() {
    return {
      form: new beegardenobject('', '', '', ''),
      response: '',
      actualBeegarden: ''
    }
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

    if (!this.currentUser) {
      this.$router.push('/login');
    } else if (this.$route.query.beegardenid) {

      BeegardenService.getSpecificBeegardenById(this.$route.query.beegardenid).then(
          response => {
            this.actualBeegarden = response.data;
            document.getElementById("beegardenName").value = this.actualBeegarden.beegardenName;
            document.getElementById("beegardenLocation").value = this.actualBeegarden.location;
          },
          error => {
            this.response =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      )
    }
  },

  methods: {
    getBackToBoardBeegarden() {
      this.$router.push('/boardbeegardens');
    },
    submitForm() {
      if (!this.currentUser)
        this.$router.push('/login');
      else if (this.$route.query.beegardenid) {

        this.putActualDataWhenNeeded();

        BeegardenService.editBeegarden(this.form, this.$route.query.beegardenid).then(
            response => {
              this.response = response.data;
              alert('Edycja pasieki przebiegła poprawnie')
              this.$router.push('/boardbeegardens');
            },
            error => {
              this.response =
                  (error.response && error.response.data && error.response.data.message) ||
                  error.message ||
                  error.toString();
            }
        )

      }
    },
    putActualDataWhenNeeded() {
      if (!this.form.type)
        this.form.type = this.actualBeegarden.type

      if (!this.form.beegardenName)
        this.form.beegardenName = this.actualBeegarden.beegardenName

      if (!this.form.location)
        this.form.location = this.actualBeegarden.location

      this.form.userId = this.currentUser.id
    }
  }
};

</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}
</style>